/**
 *******************************************************************************
 * @file    main.h
 * @brief   The header file for main.c of SBI slave demo for the
 *          TOSHIBA 'TMPM061' Application Notes 
 * @version V0.101
 * @date    2014/05/20
 * 
 * DO NOT USE THIS SOFTWARE WITHOUT THE SOFTWARE LICENSE AGREEMENT.
 * 
 * (C)Copyright TOSHIBA ELECTRONIC DEVICES & STORAGE CORPORATION 2017 All rights reserved
 *******************************************************************************
 */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#include "tmpm061_sbi.h"
#include "sw.h"
#include "lcd.h"
#include "led.h"

#define SELF_ADDR                ((uint8_t)0xE0)
#define SLAVE_ADDR               ((uint8_t)0xB0)
#define SBI_I2C_SEND             ((uint32_t)0x00000000)

#define MODE_SBI_I2C_IDLE        ((uint8_t)0x00)
#define MODE_SBI_MASTER_INITIAL  ((uint8_t)0x01)
#define MODE_SBI_SLAVE_INITIAL   ((uint8_t)0x02)
#define MODE_SBI_I2C_START       ((uint8_t)0x03)
#define MODE_SBI_I2C_TRX         ((uint8_t)0x04)
#define MODE_SBI_MASTER_FINISHED ((uint8_t)0x05)
#define MODE_SBI_SLAVE_FINISHED  ((uint8_t)0x06)

extern uint32_t gI2CWCnt;
extern uint32_t gI2CRCnt;
extern uint32_t gI2CTxDataLen;
extern char gI2CTxData[16];
extern uint32_t gI2CRxDataLen;
extern char gI2CRxData[16];

void SBI_IO_Configuration(void);


#endif                          /* __MAIN_H */
