/** 
 *******************************************************************************
 * @file    main.c
 * @brief   the application functions of TMRB_TIMER demo for the TOSHIBA
 *          'TMPM061' Device Series 
 * @version V0.101
 * @date    2014/05/20
 * 
 * DO NOT USE THIS SOFTWARE WITHOUT THE SOFTWARE LICENSE AGREEMENT.
 * 
 * (C)Copyright TOSHIBA ELECTRONIC DEVICES & STORAGE CORPORATION 2017 All rights reserved
 *******************************************************************************
 */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/**
  * @brief  The main function of TMR16A_TIMER demo
  * @param  None
  * @retval None
  */
int main(void)
{

    LED_Init();                  /* LED initialize */
    LED_On(LED_ALL);            /* Turn on LED_ALL */

    TMR16A_SetRunState(TSB_T16A0, TMR16A_STOP);  /* counter stops*/
    TMR16A_SetSrcClk(TSB_T16A0, TMR16A_SYSCK);   /* set source clock is system clock */
    TMR16A_ChangeCycle(TSB_T16A0, TMR16A_1MS);   /* Set a counter value is 1ms*/
    /* Before starting counter operation, set "0x0000" to T16AxCP<CP> to clear the counter*/
    TMR16A_ClrCaptureValue(TSB_T16A0);
    NVIC_EnableIRQ(INTT16A0_IRQn);
    TMR16A_SetRunState(TSB_T16A0, TMR16A_RUN);

    while (1) {
        /* Do nothing */
    }
}

/**
  * @brief  Deal with the error parameter
  * @param  file: Pointer to the file where the error parameter locates
  * @param  line: Number of the line in which the error parameter locates
  * @retval None
  */
#ifdef DEBUG
void assert_failed(char *file, int32_t line)
{
    while (1) {
        __NOP();
    }
}
#endif
