/**
 *******************************************************************************
 * @file    tmpm061_sio_int.c
 * @brief   interrupt request functions definition of SIO_Demo 
 * @version V0.101
 * @date    2014/05/20
 * 
 * DO NOT USE THIS SOFTWARE WITHOUT THE SOFTWARE LICENSE AGREEMENT.
 * 
 * (C)Copyright TOSHIBA ELECTRONIC DEVICES & STORAGE CORPORATION 2017 All rights reserved
 *******************************************************************************
 */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/**
  * @brief  INTTX0 Interrupt Service Routine.
  * @param  None
  * @retval None
  */
void INTTX0_IRQHandler(void)
{
    fSIO0TxOK = 1U;
}

/**
  * @brief  INTRX3 Interrupt Service Routine.
  * @param  None
  * @retval None
  */
void INTRX3_IRQHandler(void)
{
    SIO3_RxBuffer[gSIO3RdIndex++] = SIO_GetRxData(SIO3);
}

/**
  * @brief  INTTX3 Interrupt Service Routine.
  * @param  None
  * @retval None
  */
void INTTX3_IRQHandler(void)
{
    fSIO3TxOK = 1U;
}

/**
  * @brief  INTRX0 Interrupt Service Routine.
  * @param  None
  * @retval None
  */
void INTRX0_IRQHandler(void)
{
    SIO0_RxBuffer[gSIO0RdIndex++] = SIO_GetRxData(SIO0);
 }
