/** 
 *******************************************************************************
 * @file    retarget.h
 * @brief   the application functions of retarget for the TOSHIBA
 *          'TMPM061' Device Series 
 * @version V0.101
 * @date    2014/05/20
 * 
 * DO NOT USE THIS SOFTWARE WITHOUT THE SOFTWARE LICENSE AGREEMENT.
 * 
 * (C)Copyright TOSHIBA ELECTRONIC DEVICES & STORAGE CORPORATION 2017 All rights reserved
 *******************************************************************************
 */
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __RETARGET_H
#define __RETARGET_H
/* Includes ------------------------------------------------------------------*/

#include "tmpm061_uart.h"
#include <stdio.h>

#define  DEF_DISABLED                   0
#define  DEF_ENABLED                    1

#define     UART2_R     DEF_ENABLED     /*Set UARTx as retarget channel*/
   
#if (UART0_R == DEF_ENABLED)
    #define UART_RETARGET               UART0
    #define TSB_RETG    TSB_PH
    #define TXD_BIT     (1U<<0U)
    #define RXD_BIT     (1U<<1U)
    #define INT_RETARGET_IRQn       INTTX0_IRQn
    #define Retartget_IRQHandler    INTTX0_IRQHandler
#elif   (UART1_R == DEF_ENABLED) 
    #define UART_RETARGET               UART1
    #define TSB_RETG    TSB_PH
    #define TXD_BIT     (1U<<3U)
    #define RXD_BIT     (1U<<4U)
    #define INT_RETARGET_IRQn       INTTX1_IRQn
    #define Retartget_IRQHandler    INTTX1_IRQHandler
#elif   (UART2_R == DEF_ENABLED) 
    #define UART_RETARGET               UART2
    #define TSB_RETG    TSB_PI
    #define TXD_BIT     (1U<<0U)
    #define RXD_BIT     (1U<<1U)
    #define INT_RETARGET_IRQn       INTTX2_IRQn       
    #define Retartget_IRQHandler    INTTX2_IRQHandler
#endif


#define BUFFER_SIZE 16U
#define SET     0x01U           /* flag is set */
#define CLEAR   0x00U           /* flag is cleared */
#define NO      0x00U           /* Send finish NG */
#define YES     0x01U           /* Send finish OK */

void Retarget_Init(void);

#endif
