/**
 ******************************************************************************
 * @file     sw.h
 * @brief    SW driver for the TOSHIBA 'TMPM061' Device Series
 * @version  V0.101
 * @date     2014/05/20
 * 
 * DO NOT USE THIS SOFTWARE WITHOUT THE SOFTWARE LICENSE AGREEMENT.
 * 
 * (C)Copyright TOSHIBA ELECTRONIC DEVICES & STORAGE CORPORATION 2017 All rights reserved
 ******************************************************************************
 */
#ifndef __SW_H
#define __SW_H

#include "TMPM061.h"

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/

#define SW0         0U
#define SW1         1U
#define SW2         2U
#define SW3         3U
#define SW4         4U
#define SW5         5U
#define SW6         6U
#define SW7         7U

#define TSB_SW          TSB_PE
#define TSB_SWS         TSB_SW

#define SW04_BIT        0x01U
#define SW15_BIT        0x02U
#define SW26_BIT        0x04U
#define SW37_BIT        0x08U
#define SWS_BIT         0x10U

#define SW04_BIT_MASK   0xFEU
#define SW15_BIT_MASK   0xFDU
#define SW26_BIT_MASK   0xFBU
#define SW37_BIT_MASK   0xF7U

#define SWS_BIT_MASK    0xEFU


/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* external variables --------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */
void SW_Init(void);
uint8_t SW_Get(uint8_t SW);

#endif                          /* SW_H */
